<?php
/******************************************************************************/
/******************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_filters{

	public function __construct(){
		$this->config = cmsCore::getInstance()->loadComponentConfig('filters');
    }

/* ==================================================================================================== */
 	private function proc_html($filter){  
  
  return $filter['value']; 
   }

 	private function proc_user($filter,$opt){  
  
    $inDB = cmsDatabase::getInstance();
    $user =   $value = $inDB->get_fields('cms_users', "id = '$opt'", 'login,nickname');  
 
    $link = '<a href="/users/'.$user['login'].'">'.$user['nickname'].'</a>';
 
   if ($filter['value']) { $link = str_replace("%value%", $link, $filter['value']); }
   return $link; 
   }
      
 	private function proc_table($filter,$opt){  
  
    $inDB = cmsDatabase::getInstance();
  
    $args = explode('|',$filter['cond']);
   
    $table_name = $args[0];
    
    $field = $args[1];
   
   if ($table_name && $field) {
    $value = $inDB->get_field($table_name, "id = '$opt'", $field);  
     }
 
   if ($filter['value']) { $value = str_replace("%value%", $value, $filter['value']); }
 
  return $value; 
   }   

/* ==================================================================================================== */

	public function procFilter($word,$opt=false){

		$filter = cmsDatabase::getInstance()->get_fields('cms_com_filters', "word = '$word'", '*');


        switch ($filter['type']){
     
         case 'user': $value = $this->proc_user($filter,$opt); break;
         case 'HTML': $value = $this->proc_html($filter); break;
         case 'table': $value = $this->proc_table($filter,$opt); break;
      
           }



    return $value;  
 
    }
/* ==================================================================================================== */

	public function getFilter($id){

		$filter = cmsDatabase::getInstance()->get_fields('cms_com_filters', "id = '$id'", '*');

    return $filter;
 
    } 
/* ==================================================================================================== */
	public function getPhrases(){

   	$filters = cmsDatabase::getInstance()->get_table('cms_com_filters', "published=1", 'word');

    return $filters;
 
    }

/* ==================================================================================================== */

	public function addItem($item){
    
      $inDB = cmsDatabase::getInstance();
    
        $item_id = $inDB->insert('cms_com_filters', $item);

        return $item_id;

    }
/* ==================================================================================================== */

	public function updateItem($id, $item){

     $inDB = cmsDatabase::getInstance();

    // dump($id);

   return $inDB->update('cms_com_filters', $item, $id);

    }










}